<?php

function getTiles($save_as, $prefix, $tw, $th, $tileSize=256, $suffix='?v=4') {
	
	$img = imagecreatetruecolor($tw, $th);
	
	$num = 1;
	$zoom = 0;
	
	$isFirst = true;
		
	do {
		$gridsize = [ ceil($tw / $tileSize), ceil($th / $tileSize) ];
		
		if ($isFirst) {
			$isFirst = false;
			list($max_x, $max_y) = $gridsize;
		} else {
			$num += $gridsize[0] * $gridsize[1];
		}		
		
		$th = floor($th/2);
		$tw = floor($tw/2);
		$zoom++;
		
	} while ($tw > $tileSize || $th > $tileSize);
	
	for($y = 0; $y < $max_y; ++$y) {
		for($x = 0; $x < $max_x; ++$x) {
			$url = $prefix.'TileGroup'.floor( ($num + ($y * $max_x) + $x) / 256).'/'.$zoom.'-'.$x.'-'.$y.'.jpg'.$suffix;
			$tile_image_bytes = file_get_contents($url);
			$tile_image_handle = imagecreatefromstring($tile_image_bytes);
			imagecopy($img, $tile_image_handle, $x*$tileSize, $y*$tileSize, 0, 0, $tileSize, $tileSize);
			
			echo "\r".str_repeat("=", ceil(79*($y*$max_x + $x)/($max_x*$max_y)) ); // progress bar
		}
		// 
	}
	
	imagejpeg($img, $save_as, 90);
}

/*
 Example usage:
 
getTiles(
	'output'.time().'.jpg',
	'http://www.theatlantic.com/media/interactives/2015/11/colorado-satellite-photo/tiles/',
	10644,
	13305
);

 */
 